Attribute VB_Name = "Region"
'//////////////////////////////////////////////////////////////
'//                       INTRODUCTION                       //
'//////////////////////////////////////////////////////////////



'   Salut,
' Apparemment tu voudrais un peut d'aide pour faire des feilles
' non-rectangulaires ...

'Voil :

'Pour faire des fentres non-rectangulaire, on doit d'abord
'crer une Rgion : c'est comme une sorte de dessin  deux
'couleurs (plein ou vide) que l'on va ensuite appliquer  une
'fentre.

'Les zones de la fentre correspondant  le couleur "plein"
'seront visibles.
'Celles correspondant  la couleur "vide" seront invisibles.

'Les zones cre sont identifies grace  leur Handle. Il sagit
'd'un numro unique attribu pour identifier tous les objets :
'Boutons, Fentres, Rgions, TextBox, etc.



'//////////////////////////////////////////////////////////////
'//                    CREER DES REGIONS                     //
'//////////////////////////////////////////////////////////////

' Pour Crer des rgions il faut utiliser une des fonctions
' suivante :
'(Les coordonne des points sont exprimes en pixels)


'CREER DES RECTANGLES
'Pour crer un rgion en forme de rectangle :

Declare Function CreateRectRgn Lib "gdi32" ( _
ByVal x1 As Long, _
ByVal y1 As Long, _
ByVal x2 As Long, _
ByVal y2 As Long) _
As Long
'X1 et Y1 indiquent les coordonnes du coin suprieur droit
'X2 et Y2 indiquent les coordonnes du coin infrieur gauche
'Cette fonction revoie le Handle de la rgion cre


'CREER DES ELLIPSES
'Pour crer une rgion en forme d'ellipse :

Declare Function CreateEllipticRgn Lib "gdi32" ( _
ByVal x1 As Long, _
ByVal y1 As Long, _
ByVal x2 As Long, _
ByVal y2 As Long) _
As Long
'Cette fonction cre une ellipse qui rentre dans le rectangle
'forme avec les coordones X1, X2, Y1, Y2
'Cette fonction revoie le Handle de la rgion cre


'CREER DES POLYGONES
'Pour crer une rgion ayant la forme d'un polygone
Declare Function CreatePolygonRgn Lib "gdi32" ( _
lpPoint As POINTAPI, _
ByVal nCount As Long, _
ByVal nPolyFillMode As Long _
) As Long

'lpPoint est un tableau dsignant les coins du polygone
'Il est de type POINTAPI :
Type POINTAPI
        X As Long
        Y As Long
End Type

'nCount dsigne le nombre de coins du polygone.

'nPolyFillMode dsigne le mode de remplissage.
'tu peux utiliser les constantes suivantes
Public Const ALTERNATE = 1
Public Const WINDING = 2
'J'avoue que je ne comprend pas la diffrence entre les deux,
'Tu peut mettre 1, a marche bien.



'//////////////////////////////////////////////////////////////
'//                  COMBINER DES REGIONS                    //
'//////////////////////////////////////////////////////////////


'Maintenant que nous pouvons crer des rgions, voici comment
'les combiner pour crer des rgions complexes.

'Il faut utiliser la fonction :

Declare Function CombineRgn Lib "gdi32" ( _
ByVal hDestRgn As Long, _
ByVal hSrcRgn1 As Long, _
ByVal hSrcRgn2 As Long, _
ByVal nCombineMode As CombineMode _
) As Long

'hDestRgn dsigne le Handle de la rgion de destination.
'/--------------------------------------------------------\
'|ATTENTION : POUR QUE CELA FONCTIONNE, IL FAUT ABSOLUMENT|
'|QUE LA REGION SOIT DEJA INITIALISEE A L'AIDE D'UNE DES  |
'|FONCTIONS VUE CI-DESSUS.                                |
'\--------------------------------------------------------/

'hSrcRgn1 dsigne le Handle de la premire Rgion  combiner
'hSrcRgn2 dsigne le Handle de la deuxime Rgion  combiner

'nCombineMode dsigne le mode utilis pour la Combinaison
'Tu peux utiliser une des constantes suivante :

Public Enum CombineMode
    RGN_AND = 1  ' Cr l'intersection des deux
                 'rgions
    RGN_COPY = 5 ' Copie la Rgion1
    RGN_DIFF = 4 ' Combine les parties de Rgion1
                 'qui ne font pas partie de rgion2
    RGN_OR = 2   ' Cr l'union des deux rgions
    RGN_XOR = 3  ' Cr l'union des deux rgions 
                 'laquelle on enleve l'intersection
                 'des deux rgions
End Enum


'//////////////////////////////////////////////////////////////
'//                  APPLIQUER DES REGIONS                   //
'//////////////////////////////////////////////////////////////

'Pour appliquer une rgion  une fentre, on utilise la
'fonction suivante :

Declare Function SetWindowRgn Lib "user32" ( _
ByVal hwnd As Long, _
ByVal hRgn As Long, _
ByVal bRedraw As Boolean _
) As Long

'hWnd indique le Handle de la fentre  laquelle on veut
'appliquer la rgion.

'hRgn indique le Handle de la rgion  appliquer.

'bRedraw indique s'il faut redessiner la fentre.
         'Mettre True si la fentre est visible
         'On peut mettre False si elle est cache.

'Note : On peut utiliser cette fonction avec le handle d'un
'contrle au lieu de celui d'une Fentre



'//////////////////////////////////////////////////////////////
'//                  SUPPRIMER DES REGIONS                   //
'//////////////////////////////////////////////////////////////

'Une fois que l'on a plus besoin de la rgion, il faut la
'supprimer pour librer de la mmoire.

'Pour cela, on peut utiliser la fonction :

Declare Function DeleteObject Lib "gdi32" ( _
ByVal hObject As Long _
) As Long

'hObject dsigne le Handle de la rgion  supprimer.

'ATTENTION  : NE PAS SUPPRIMER UNE REGION QUI EST APPLIQUEE
'A UNE FENETRE. CELA AURAIT POUR EFFET DE LAISSER LA FENETRE
'IMPRIMEE SUR LE BUREAU (CA FAIT PAS BEAU)
